; **
; Intellivision for GameBoy Color v1.1
; Copyright(C) 2000,03 By Carl Mueller, Jr.
;
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

CopyrightMsgs::

        DB              "  Intellivision for ", 0
        DB              "      GameBoy Color ", 0
        DB              "               v1.1 ", 0

        DB              "By Carl Mueller, Jr.", 0
        DB              " Copyright @2000,03 ", 0
        DB              "All rights reserved.", 0

        DB              " This user-compiled ", 0
        DB              " binary MAY contain ", 0
        DB              "copyrighted material", 0
        DB              "supplied by the user", 0

        DB              "    The original    ", 0
        DB              "distribution package", 0
        DB              "    contains NO     ", 0
        DB              "copyrighted material", 0
        DB              "     whatsoever     ", 0

icWHITE   EQU           31 << 10 + 31 << 5 + 31 << 0

icPINK    EQU           16 << 10 + 5 << 5 + 24 << 0          ; 49, 10, 32
icPURPLE  EQU           22 << 10 + 0 << 5 + 14 << 0          ; 28,  0, 44
icGREEN   EQU           15 << 10 + 31 << 5 + 15 << 0         ; 31, 62, 30
icYELLOW  EQU           0 << 10 + 26 << 5 + 28 << 0          ; 56, 53, 0
icBLUE    EQU           24 << 10 + 21 << 5 + 5 << 0          ; 10, 42, 49

icPAL2  DW              icBLACK, icBLACK, icBLACK, icPINK    ; #0 \
        DW              icBLACK, icBLACK, icBLACK, icPURPLE  ; #1 / WINPAL_0
        DW              icBLACK, icBLACK, icBLACK, icWHITE   ; #2
        DW              icBLACK, icBLACK, icBLACK, icGREY    ; #3
        DW              icBLACK, icBLACK, icBLACK, icRED     ; #4
        DW              icBLACK, icBLACK, icBLACK, icGREEN   ; #5
        DW              icBLACK, icBLACK, icBLACK, icYELLOW  ; #6
        DW              icBLACK, icBLACK, icBLACK, icBLUE    ; #7

Copyright::

.VBL    ldh             a, [rSTAT]      ; a <- LCDC Status
        and             $03
        cp              STATF_VB        ; are we in V-Blank ?
        jr              nz, .VBL        ; no, so wait until we are

        ld              de, rBCPS       ; de -> Bkg Color Palette Spec Reg

        ld              a, $80          ; auto-advance, palette #0, color #0
        ld              [de], a
        inc             e               ; de -> Bkg Color Palette Data Reg

        ld              hl, icPAL2
        ld              c, 4 * 2 * 2    ; 4 colors @ 2 bytes ea., 2 palettes
.WinPal
        ld              a, [hl+]
        ld              [de], a

        dec             c
        jr              nz, .WinPal

;        ld              a, 7 + 4
;        ldh             [rWX], a        ; set Window X = 4

        ; set up palette by modifying PALTAB_0 (see VBlankFunc)

        ld              a, 3
        ldh             [cSVBK], a
        ldh             [rSVBK], a      ; switch to WRAM bank #3

        ld              de, PALTAB_0 + 2 * PALTAB_PALSIZE
        ld              c, 4 * 2 * 6    ; 4 colors @ 2 bytes ea., 6 palettes
.PalTab
        ld              a, [hl+]
        ld              [de], a
        inc             e
        dec             c
        jr              nz, .PalTab

        ld              a, 1
        ldh             [cSVBK], a
        ldh             [rSVBK], a      ; switch to WRAM bank #1

        ld              [Page_Ready], a ; make sure PALTAB_0 gets updated

        ; clear the background, setting all tiles to the upper-tile bank

        ld              a, $0A                      ; set Attribute Byte
        ld              bc, ( $00 - 32 ) << 8 + 32  ; set Tile Base, RepChar
        ld              de, 32 * 32                 ; set #/iterations
        ld              hl, _SCRN1                  ; set Destination

        call            RepChar         ; clear _SCRN1

        ; finally, let's write out the relevant information

        ld              de, CopyrightMsgs  ; set Source Address

        ld              hl, _SCRN1 + 0 * 32
        call            WriteStr                 ; "  Intellivision for "
        ld              hl, _SCRN1 + 1 * 32
        call            WriteStr                 ; "      GameBoy Color "
        ld              hl, _SCRN1 + 2 * 32
        call            WriteStr                 ; "               v1.1 "

        ld              hl, _SCRN1 + 15 * 32
        call            WriteStr                 ; "By Carl Mueller, Jr."
        ld              hl, _SCRN1 + 16 * 32
        call            WriteStr                 ; " Copyright @2000,03 "
        ld              hl, _SCRN1 + 17 * 32
        call            WriteStr                 ; "All rights reserved."

        ld              a, $0C          ; red (palette #4), upper-tile bank

        ld              hl, _SCRN1 + 4 * 32
        call            WriteStr                 ; " This user-compiled "
        ld              hl, _SCRN1 + 5 * 32
        call            WriteStr                 ; " binary MAY contain "
        ld              hl, _SCRN1 + 6 * 32
        call            WriteStr                 ; "copyrighted material"
        ld              hl, _SCRN1 + 7 * 32
        call            WriteStr                 ; "supplied by the user"

        ld              a, $0B          ; grey (palette #4), upper-tile bank

        ld              hl, _SCRN1 + 9 * 32
        call            WriteStr                 ; "    The original    "
        ld              hl, _SCRN1 + 10 * 32
        call            WriteStr                 ; "distribution package"
        ld              hl, _SCRN1 + 11 * 32
        call            WriteStr                 ; "    contains NO     "
        ld              hl, _SCRN1 + 12 * 32
        call            WriteStr                 ; "copyrighted material"
        ld              hl, _SCRN1 + 13 * 32
        call            WriteStr                 ; "     whatsoever     "

        ; draw out "CoLoR" in Pink, Purple, Green, Yellow, and Blue

        ld              a, $08          ; pink (palette #0), upper-tile bank

        ld              c, "C"                      ; set RepChar
        ld              de, 1                       ; set #/iterations
        ld              hl, _SCRN1 + 1 * 32 + 14    ; set Destination

        call            RepChar         ; "C"

        inc             a               ; purple (palette #1), upper-tile bank

        ld              c, "o"          ; set RepChar
        inc             e               ; set #/iterations

        call            RepChar         ; "O"

        ld              a, $0D          ; green (palette #5), upper-tile bank

        ld              c, "L"          ; set RepChar
        inc             e               ; set #/iterations

        call            RepChar         ; "L"

        inc             a               ; yellow (palette #6), upper-tile bank

        ld              c, "o"          ; set RepChar
        inc             e               ; set #/iterations

        call            RepChar         ; "O"

        inc             a               ; blue (palette #7), upper-tile bank

        ld              c, "R"          ; set RepChar
        inc             e               ; set #/iterations

        call            RepChar         ; "R"

        ; V-Blank and/or H-Blank interrupts are no doubt pending, so
        ; let's wait for the V-Blank period before re-enabling interrupts

.Wait_VB

        ldh             a, [rSTAT]      ; a <- LCDC Status
        and             $03
        cp              STATF_VB        ; are we in V-Blank ?
        jr              nz, .Wait_VB    ; no, so wait until we are

        xor             a
        ldh             [STIC_Display_Hi], a  ; display window only

        ei                              ; let the interrupts commence

        ld              c, 25
        ld              de, 0
.Delay
        dec             de

        ld              a, e
        or              d
        jr              nz, .Delay

        dec             c
        jr              nz, .Delay

;.Wait_Release
;
;        call            ReadJoy
;
;        ld              a, [JoyDown]       ; a <- buttons currently held down
;        or              a                  ; any held down ?
;        jr              nz, .Wait_Release  ; yes, so wait until released
;
;.Wait_Press
;
;        call            ReadJoy
;
;        ld              a, [JoyDown]       ; a <- buttons currently held down
;        or              a                  ; any held down ?
;        jr              z, .Wait_Press     ; nope, so wait until pressed
;
;.Wait_Release2
;
;        call            ReadJoy
;
;        ld              a, [JoyDown]       ; a <- buttons currently held down
;        or              a                  ; any held down ?
;        jr              nz, .Wait_Release2  ; yes, so wait until released

        di

.VBL2   ldh             a, [rSTAT]      ; a <- LCDC Status
        and             $03
        cp              STATF_VB        ; are we in V-Blank ?
        jr              nz, .VBL2       ; no, so wait until we are

        ld              hl, rBCPS       ; de -> Bkg Color Palette Spec Reg

        ld              a, $86          ; auto-advance, palette #0, color #3
        ld              [hl+], a

        xor             a
        ld              [hl], a
        ld              [hl], a         ; Black

        ld              bc, ( $00 - 0 ) << 8 + $F9  ; set Tile Base, RepChar
        ld              de, 32 * 32                 ; set #/iterations
        ld              hl, _SCRN1                  ; set Destination

        call            RepChar         ; clear _SCRN1

        ld              a, 7
        ldh             [rWX], a        ; set Window X = 7

        ret
