; **
; Intellivision for GameBoy Color v1.1
; Copyright(C) 2000,03 By Carl Mueller, Jr.
;
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

RANGE:          MACRO

;                PRINTT      "\1-\2: "
;                PRINTV      ( ( \2 - \1 ) & $FF00 ) >> 8 + 1
;                PRINTT      "\n"

PAGE_NO         SET         0
                REPT        ( ( \2 - \1 ) & $FF00 ) >> 8 + 1

                DB          ( ( \3 + \4 ) >> 1 ) >> 8 + PAGE_NO
                DB          BANK(\3) & $FF

                IF          "\3" != "EMPTY"
PAGE_NO         SET         PAGE_NO + 1
                ENDC
                ENDR

                ENDM

        ; -------------------------------------------------------------------
        ;           .::** Intellivision (fixed) mapping **::.
        ; -------------------------------------------------------------------

        RANGE   $0000, $003F, STIC, 0
        RANGE   $0100, $01FF, SCRATCHPAD_RAM, 0
        RANGE   $0200, $035F, SYSTEM_RAM, 0
        RANGE   $0400, $0FFF, EMPTY, 0
        RANGE   $1000, $1FFF, EXEC, 0
        RANGE   $2000, $2FFF, EMPTY, 0
        RANGE   $3000, $37FF, GROM_16, 0
        RANGE   $3800, $39FF, GRAM_16, 0
        RANGE   $3A00, $3BFF, GRAM_16, 0
        RANGE   $3C00, $3DFF, GRAM_16, 0
        RANGE   $3E00, $3FFF, GRAM_16, 0
;        RANGE   $4000, $40FF, STACK, 0
        RANGE   $4000, $40FF, EMPTY, 0
        RANGE   $4100, $41FF, BKTCODE, 0
        RANGE   $4200, $47FF, EMPTY, 0

        ; -------------------------------------------------------------------
        ;              .::** Standard MATTEL mapping **::.
        ; -------------------------------------------------------------------

        IF      MAPPING == mtMattel

        RANGE   $4800, $4FFF, EMPTY, 0
        RANGE   $5000, $6FFF, GAME_1, 0

        IF      GAME_SPLITS > 1

        RANGE   $7000, $CFFF, EMPTY, 0
        RANGE   $D000, $DFFF, GAME_2, 0
        RANGE   $E000, $EFFF, EMPTY, 0
        RANGE   $F000, $FFFF, GAME_2, $2000

        ELSE

        RANGE   $7000, $FFFF, EMPTY, 0

        ENDC

        ENDC

        ; -------------------------------------------------------------------
        ;            .::** Standard INTV CORP. mapping **::.
        ; -------------------------------------------------------------------

        IF      MAPPING == mtIntv

        RANGE   $4800, $4FFF, EMPTY, 0
        RANGE   $5000, $6FFF, GAME_1, 0
        RANGE   $7000, $8FFF, EMPTY, 0
        RANGE   $9000, $AFFF, GAME_2, 0
        RANGE   $B000, $FFFF, EMPTY, 0

        ENDC

        ; -------------------------------------------------------------------
        ;                  .::** IMAGIC mapping **::.
        ; -------------------------------------------------------------------

        IF      MAPPING == mtImagic

        RANGE   $4800, $67FF, GAME_1, 0
        RANGE   $6800, $FFFF, EMPTY, 0

        ENDC

        ; -------------------------------------------------------------------
        ;      .::** Special mapping for PACMAN and CONGO BONGO **::.
        ; -------------------------------------------------------------------

        IF      MAPPING == mtPacMan

        RANGE   $4800, $4FFF, EMPTY, 0
        RANGE   $5000, $6FFF, GAME_1, 0
        RANGE   $7000, $8FFF, GAME_2, 0
        RANGE   $9000, $FFFF, EMPTY, 0

        ENDC

        ; -------------------------------------------------------------------
        ;            .::** Special mapping for CENTIPEDE **::.
        ; -------------------------------------------------------------------

        IF      MAPPING == mtCentipede

        RANGE   $4800, $5FFF, EMPTY, 0
        RANGE   $6000, $7FFF, GAME_1, 0
        RANGE   $8000, $FFFF, EMPTY, 0

        ENDC

        ; -------------------------------------------------------------------
        ;       .::** Mapping generated by an external program **::.
        ; -------------------------------------------------------------------

        IF      MAPPING == mtOther

        INCLUDE "MAPPING.INC"

        ENDC
