; **
; Intellivision for GameBoy Color v1.1
; Copyright(C) 2000,03 By Carl Mueller, Jr.
;
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

BUMPJUMP_D1C1::

;$D1C1 : MVO   R6, $035F     ; !!!               ; $246, 582 d, 1001000110 "F"
;$D1C3 : MVO@  R4, R6                            ; $274, 628 d, 1001110100 "t"
;$D1C4 : JSR   R5, $1AF4                         ; $004, 4   d, 0000000100
;$D1C7 : MVI@  R6, R4                            ; $2B4, 692 d, 1010110100

        di

        ld              hl, SYSTEM_RAM + $015F * 2

        xor             a
        ld              [hl+], a
        ld              [hl], $03       ; [$035F] <- $0300

        ld              sp, R4          ; sp -> R4

        pop             de

        ld              l, a

        ld              [hl], e
        inc             l
        ld              [hl], d         ; [$0300] <- [R4]

        ld              sp, $4386       ; return to BUMPJUMP @ $D1C3

        reti

SNAFU_50D9::

        di                              ; don't allow VBlankFunc to interrupt

        ld              c, 8 << 1       ; Gray

SNAFU_50C9::

        ld              de, 8 << 8 + 4 << 1  ; Dark Green

        ld              sp, SP_1        ; use STACK_1 for SNAFU_50C9

        call            SetCol0         ; set Color #0 of each Palette

        ld              sp, $4198       ; return to SNAFU @ $50CC

        reti                            ; return, enabling interrupts

SPCBATTL_5C28::

        di                              ; don't allow VBlankFunc to interrupt

        ld              a, [R2]
        ld              [SCRATCHPAD_RAM + $0AE * 2], a

        ld              c, 2 << 1       ; Red

SPCBATTL_5C32::

        ld              de, 8 << 8 + 2 << 1  ; Red

        ld              sp, SP_1        ; use STACK_1 for SPCBATTL_5C32

        call            SetCol0         ; set Color #0 of each Palette

        ld              sp, $5866       ; return to SPCBATTL @ $5C33

        reti                            ; return, enabling interrupts

SHRPSHOT_52F2::

        ld              sp, SP_1        ; use STACK_1 for SHRPSHOT_52F2

        ld              a, [R2 + 1]     ; a = ??aFtNNn (HIGH byte of [R2])

        swap            a               ;   = tNNn??aF
        add             a, a            ;   = NNn??aF.
        and             $04             ;   = .....a.. (Advance)

        ld              c, a            ; c = 0 (Black) or 4 (Red)

        ld              d, 8            ; do 8 palettes

        call            SetCol0         ; set Color #0 of each Palette

        ld              sp, $45E8       ; return to SHRPSHOT @ $52F4

        reti                            ; return, enabling interrupts

BLOCKADR_5352::

        ld              hl, R1          ; hl -> R1

        ld              a, [hl-]        ; a <- R1 (STIC register number)
        cp              $28             ; is it ColorStack #0 ?
        jr              z, .CS0         ; yes, so ...

        ld              de, R0          ; de -> R0

        jp              AP_STIC         ; write to other STIC register
.CS0
        dec             l
        ld              a, [hl]         ; a <- LOW byte of [R0]

        add             a, a
        ld              c, a

        ld              d, 3            ; do 2 palettes only

        ld              sp, SP_1        ; use STACK_1 for BLOCKADR_5352

        call            SetCol0         ; set Color #0 of each Palette

        ld              sp, $46A6       ; return to BLOCKADR @ $5353

        reti                            ; return, enabling interrupts



