; **
; Intellivision for GameBoy Color v1.1
; Copyright(C) 2000,03 By Carl Mueller, Jr.
;
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

PATBYTE: MACRO

        DB              ( ( \1 ) >> 5 ) & $F8 + 0
        DB              ( \1 ) & $FF
        DB              \2

        ENDM

PATWORD: MACRO

        DB              ( ( \1 ) >> 5 ) & $F8 + 1
        DB              ( \1 ) & $FF
        DW              \2

        ENDM

;RT_Patch::
;
;        ld              hl, rtPatData
;.Loop
;        ld              a, [hl+]
;        ld              e, a
;        ld              a, [hl+]
;        ld              d, a            ; de <- PatchAddr
;
;        ld              a, [hl+]        ; a <- PatchByte
;
;        ld              [de], a         ; [PatchAddr] <- PatchByte
;
;        ld              a, e
;        or              d               ; was PatchAddr = 0 ?
;        jr              nz, .Loop       ; nope, so let's patch away
;
;        ret

rtPatData:

        IF              PATCHES == ptBeauty

        ; Parameters:   * OS_PB = ProcBitMap      * OS_RR = RomRec
        ;               * OS_RA = RetAddr         * OS_C1 = Convert #1
        ;               * OS_C2 = Convert #2      * OS_CA = ContAddr

        PATBYTE         OS_PB + 1, $0D * 2        ; ProcBitMap = $010D
        PATBYTE         OS_RR + 1, $30            ; RomRec     = $0330
        PATWORD         OS_RA + 1, $489C          ; RetAddr    = $489C
        PATWORD         OS_C1 + 1, $4000 >> 1 - $4800 - 1
        PATBYTE         OS_C2 + 1, ( $4000 >> 1 - $4800 ) >> 8
        PATWORD         OS_CA + 1, $4146          ; ContAddr   = $4146

        ; Parameters:   * CC_XP = XPos            * CC_CD = CollInfo Dist.
        ;               * CC_C1 = Convert #1        CC_IM = Info & Mask
        ;               * CC_CI = CollInfo        * CC_CA = ContAddr
        ;               * CC_RA = RetAddr         * CC_C2 = Convert #2

        PATBYTE         CC_XP + 1, $18 * 2 + 1    ; XPos       = $0318
        PATBYTE         CC_CD + 1, ( $034F - $0330 ) * 2
        PATWORD         CC_C1 + 1, $4000 >> 1 - $4800 + 5
        PATBYTE         CC_CI + 1, $4F * 2        ; CollInfo   = $034F
        PATWORD         CC_CA + 1, $41EC          ; ContAddr   = $41EC
        PATWORD         CC_RA + 1, $48DF          ; RetAddr    = $48DF
        PATWORD         CC_C2 + 1, $4000 >> 1 - $4800

        ; Parameters:   * US_XP = XPos            * US_SB = SticBase
        ;               * US_CA = ContAddr        * US_SC = SticComp

        PATBYTE         US_XP + 1, $18 * 2 - 1    ; XPos       = $0318
        PATBYTE         US_SB + 1, $18 * 2 - 1    ; SticBase   = $0318
        PATBYTE         US_SC + 1, ( $18 + 24 ) * 2 - 1
        PATWORD         US_CA + 1, $4320          ; ContAddr   = $4320

        ; Parameters:   * GC_CI = CollInfo        * GC_CA = ContAddr

        PATBYTE         GC_CI + 1, $4F * 2        ; CollInfo   = $034F
        PATWORD         GC_CA + 1, $4360          ; ContAddr   = $4360

        ; Parameters:   * CA_RR = RomRecList      * CA_C1 = Convert #1
        ;               * CA_RS = RomRecToSQPC    * CA_SR = SQPCToRomRec
        ;               * CA_EA = EndAddr         * CA_CA = ContAddr

        PATBYTE         CA_RR + 1, $30 * 2        ; RomRecList = $0330
        PATBYTE         CA_C1 + 1, ( $4000 >> 1 - $4800 ) >> 8
        PATBYTE         CA_EA + 1, $38 * 2        ; EndAddr    = $0338
        PATWORD         CA_CA + 1, $42BA          ; ContAddr   = $42BA

        ; Parameters:   * BC_RR = RomRecList      * BC_C1 = Convert #1
        ;               * BC_RS = RomRecToSQPC    * BC_SR = SQPCToRomRec
        ;               * BC_EA = EndAddr         * BC_CA = ContAddr

        PATBYTE         BC_RR + 1, $5D * 2        ; RomRecList = $015D
        PATBYTE         BC_C1 + 1, ( $4000 >> 1 - $4800 ) >> 8
        PATWORD         BC_RS + 1, ( SYSTEM_RAM + $148 * 2 ) - ( SCRATCHPAD_RAM + $05D * 2 ) >> 1 + 1
        PATWORD         BC_SR + 1, ( SCRATCHPAD_RAM + $05D * 2 ) >> 1 - ( SYSTEM_RAM + $148 * 2 ) + 1
        PATBYTE         BC_EA + 1, $6B * 2        ; EndAddr    = $016B
        PATWORD         BC_CA + 1, $42BA          ; ContAddr   = $42BA

        ; Parameters:   * AV_O1 = ObjUpd1         * AV_XA = XAdj
        ;               * AV_XP = XPos            * AV_O2 = ObjUpd2
        ;               * AV_YA = YAdj            * AV_CA = ContAddr
        ;
        ;               * AV_P1 = PosToFrac1      * AV_P2 = PosToFrac2
        ;               * AV_DP = DcmlPt            AV_PA = PosAdj

        PATWORD         AV_O1 + 1, SinTab + 2 * 2 ; CY         = 1
        PATBYTE         AV_XP + 1, $18 * 2 + 1    ; XPos       = $0318
        PATWORD         AV_O2 + 1, SinTab + 2 * 0 ; CY         = 0
        PATWORD         AV_CA + 1, $44E8          ; ContAddr   = $44E8
        PATWORD         AV_P1 + 1, ( ( SCRATCHPAD_RAM + $025 * 2 ) - ( SYSTEM_RAM + $118 * 2 ) << 1 ) & $FFFF + 6
        PATWORD         AV_P2 + 1, ( ( SCRATCHPAD_RAM + $025 * 2 ) - ( SYSTEM_RAM + $118 * 2 ) << 1 ) & $FFFF + 2
        PATBYTE         AV_DP + 1, $0C * 2        ; DcmlPt     = $010C

        ENDC

        IF              PATCHES == ptOther

        INCBIN          "RTPAT.BIN"

        ENDC

        DB              0               ; end of patch data
