; **
; Intellivision for GameBoy Color v1.1
; Copyright(C) 2000,03 By Carl Mueller, Jr.
;
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

; ---------------------------------------------------------------------------
;                        .::** CopyToVRAM **::.
; ---------------------------------------------------------------------------

TC00:    MACRO

         pop            de              ; de <- card's data address
         pop            hl              ; hl <- card's VRAM address

         xor            a

         REPT           8
         ld             [hl+], a        ; 1st line <- zero
         ld             [hl+], a        ; 2nd line <- zero
         ENDR

         ; ^ 39 cycles, 19 bytes

         ENDM

TC01:    MACRO

         pop            de              ; de <- card's data address
         pop            hl              ; hl <- card's VRAM address

         REPT           7               ; do the first 7 lines
         ld             a, [de]
         inc            e
         cpl
         ld             [hl+], a        ; 1st line <- source byte (inverted)
         xor            a
         ld             [hl+], a        ; 2nd line <- zero
         ENDR

         ld             a, [de]
         cpl
         ld             [hl+], a        ; 1st line <- source byte (inverted)
         xor            a
         ld             [hl+], a        ; 2nd line <- zero

         ; ^ 77 cycles, 49 bytes

         ENDM

TC02:    MACRO

         pop            de              ; de <- card's data address
         pop            hl              ; hl <- card's VRAM address

         REPT           7               ; do the first 7 lines
         xor            a
         ld             [hl+], a        ; 1st line <- zero
         ld             a, [de]
         inc            e
         cpl
         ld             [hl+], a        ; 2nd line <- source byte (inverted)
         ENDR

         xor            a
         ld             [hl+], a        ; 1st line <- zero
         ld             a, [de]
         cpl
         ld             [hl+], a        ; 2nd line <- source byte (inverted)

         ; ^ 77 cycles, 49 bytes

         ENDM

TC03:    MACRO

         pop            de              ; de <- card's data address
         pop            hl              ; hl <- card's VRAM address

         REPT           7               ; do the first 7 lines
         ld             a, [de]
         inc            e
         cpl
         ld             [hl+], a        ; 1st line <- source byte (inverted)
         ld             [hl+], a        ; 2nd line <- source byte (inverted)
         ENDR

         ld             a, [de]
         cpl
         ld             [hl+], a        ; 1st line <- source byte (inverted)
         ld             [hl+], a        ; 2nd line <- source byte (inverted)

         ; ^ 69 cycles, 41 bytes

         ENDM

TC04:    MACRO

         pop            hl              ; hl <- card's data address
         pop            de              ; de <- card's VRAM address

         ld             sp, hl          ; sp <- card's data address
         ld             l, e
         ld             h, d            ; hl <- card's VRAM address

         xor            a

         REPT           4

         pop            de              ; d <- 2nd source byte, e <- 1st byte

         ld             [hl], e         ; 1st line <- source byte
         inc            l
         ld             [hl+], a        ; 2nd line <- zero

         ld             [hl], d         ; 1st line <- source byte
         inc            l
         ld             [hl+], a        ; 2nd line <- zero

         ENDR

         ; ^ 63 cycles, 34 bytes

         ENDM

TC05:    MACRO

         pop            de              ; * de <- card's data address
         pop            hl              ; hl <- card's VRAM address

         xor            a
         ld             e, a            ; e = 0
         dec            a               ; a = $FF

         REPT           7
         ld             [hl+], a        ; 1st line <- all one's
         ld             [hl], e         ; 2nd line <- zero
         inc            l
         ENDR

         ld             [hl+], a        ; 1st line <- all one's
         ld             [hl], e         ; 2nd line <- zero

         ; ^ 48 cycles, 28 bytes

         ENDM

TC06:    MACRO

         pop            de              ; de <- card's data address
         pop            hl              ; hl <- card's VRAM address

         REPT           7               ; do the first 7 lines
         ld             a, [de]
         inc            e
         ld             [hl+], a        ; 1st line <- source byte
         cpl
         ld             [hl+], a        ; 2nd line <- source byte (inverted)
         ENDR

         ld             a, [de]
         ld             [hl+], a        ; 1st line <- source byte
         cpl
         ld             [hl+], a        ; 2nd line <- source byte (inverted)

         ; ^ 69 cycles, 41 bytes

         ENDM

TC07:    MACRO

         pop            hl              ; hl <- card's data address
         pop            de              ; de <- card's VRAM address

         ld             sp, hl          ; sp <- card's data address
         ld             l, e
         ld             h, d            ; hl <- card's VRAM address

         ld             a, $FF

         REPT           3

         pop            de              ; d <- 2nd source byte, e <- 1st byte

         ld             [hl+], a        ; 1st line <- all ones
         xor            e
         ld             [hl+], a        ; 2nd line <- source byte (inverted)
         xor            e

         ld             [hl+], a        ; 1st line <- all ones
         xor            d
         ld             [hl+], a        ; 2nd line <- source byte (inverted)
         xor            d

         ENDR                           ; 45

         pop            de              ; d <- 2nd source byte, e <- 1st byte

         ld             [hl+], a        ; 1st line <- all ones
         xor            e
         ld             [hl+], a        ; 2nd line <- source byte (inverted)
         xor            e

         ld             [hl+], a        ; 1st line <- all ones
         xor            d
         ld             [hl+], a        ; 2nd line <- source byte (inverted)

         ; ^ 70 cycles, 42 bytes

         ENDM

TC08:    MACRO

         pop            hl              ; hl <- card's data address
         pop            de              ; de <- card's VRAM address

         ld             sp, hl          ; sp <- card's data address
         ld             l, e
         ld             h, d            ; hl <- card's VRAM address

         xor            a

         REPT           3

         pop            de              ; d <- 2nd source byte, e <- 1st byte

         ld             [hl+], a        ; 1st line <- zero
         ld             [hl], e         ; 2nd line <- source byte
         inc            l

         ld             [hl+], a        ; 1st line <- zero
         ld             [hl], d         ; 2nd line <- source byte
         inc            l

         ENDR                           ; 39 cycles

         pop            de              ; d <- 2nd source byte, e <- 1st byte

         ld             [hl+], a        ; 1st line <- zero
         ld             [hl], e         ; 2nd line <- source byte
         inc            l

         ld             [hl+], a        ; 1st line <- zero
         ld             [hl], d         ; 2nd line <- source byte

         ; ^ 62 cycles, 33 bytes

         ENDM

TC09:    MACRO

         pop            de              ; de <- card's data address
         pop            hl              ; hl <- card's VRAM address

         REPT           7               ; do the first 7 lines
         ld             a, [de]
         inc            e
         cpl
         ld             [hl+], a        ; 1st line <- source byte (inverted)
         cpl
         ld             [hl+], a        ; 2nd line <- source byte
         ENDR

         ld             a, [de]
         cpl
         ld             [hl+], a        ; 1st line <- source byte (inverted)
         cpl
         ld             [hl+], a        ; 2nd line <- source byte

         ; ^ 77 cycles, 49 bytes

         ENDM

TC10:    MACRO

         pop            de              ; * de <- card's data address
         pop            hl              ; hl <- card's VRAM address

         xor            a
         ld             e, $FF

         REPT           7               ; do the first 7 lines
         ld             [hl+], a        ; 1st line <- zero
         ld             [hl], e         ; 2nd line <- all ones
         inc            l
         ENDR

         ld             [hl+], a        ; 1st line <- zero
         ld             [hl], e         ; 2nd line <- all ones

         ; ^ 49 cycles, 28 bytes

         ENDM

TC11:    MACRO

         pop            hl              ; hl <- card's data address
         pop            de              ; de <- card's VRAM address

         ld             sp, hl          ; sp <- card's data address
         ld             l, e
         ld             h, d            ; hl <- card's VRAM address

         ld             a, $FF

         REPT           4

         pop            de              ; d <- 2nd source byte, e <- 1st byte

         xor            e
         ld             [hl+], a        ; 1st line <- source byte (inverted)
         xor            e
         ld             [hl+], a        ; 2nd line <- all ones

         xor            d
         ld             [hl+], a        ; 1st line <- source byte (inverted)
         xor            d
         ld             [hl+], a        ; 2nd line <- all ones

         ENDR                           ; 60 cycles

         ; ^ 71 cycles, 43 bytes

         ENDM

TC12:    MACRO

         pop            de              ; de <- card's data address
         pop            hl              ; hl <- card's VRAM address

         REPT           7               ; do the first 7 lines
         ld             a, [de]
         inc            e
         ld             [hl+], a        ; 1st line <- source byte
         ld             [hl+], a        ; 2nd line <- source byte
         ENDR                           ; 49 cycles

         ld             a, [de]
         ld             [hl+], a        ; 1st line <- source byte
         ld             [hl+], a        ; 2nd line <- source byte

         ; ^ 61 cycles, 33 bytes

         ENDM

TC13:    MACRO

         pop            hl              ; hl <- card's data address
         pop            de              ; de <- card's VRAM address

         ld             sp, hl          ; sp <- card's data address
         ld             l, e
         ld             h, d            ; hl <- card's VRAM address

         ld             a, $FF

         REPT           3

         pop            de              ; d <- 2nd source byte, e <- 1st byte

         ld             [hl+], a        ; 1st line <- all ones
         ld             [hl], e         ; 2nd line <- source byte
         inc            l

         ld             [hl+], a        ; 1st line <- all ones
         ld             [hl], d         ; 2nd line <- source byte
         inc            l

         ENDR                           ; 39 cycles

         pop            de              ; d <- 2nd source byte, e <- 1st byte

         ld             [hl+], a        ; 1st line <- all ones
         ld             [hl], e         ; 2nd line <- source byte
         inc            l

         ld             [hl+], a        ; 1st line <- all ones
         ld             [hl], d         ; 2nd line <- source byte

         ; ^ 62 cycles, 34 bytes

         ENDM

TC14:    MACRO

         pop            hl              ; hl <- card's data address
         pop            de              ; de <- card's VRAM address

         ld             sp, hl          ; sp <- card's data address
         ld             l, e
         ld             h, d            ; hl <- card's VRAM address

         ld             a, $FF

         REPT           4

         pop            de              ; d <- 2nd source byte, e <- 1st byte

         ld             [hl], e         ; 1st line <- source byte
         inc            l
         ld             [hl+], a        ; 2nd line <- all ones

         ld             [hl], d         ; 1st line <- source byte
         inc            l
         ld             [hl+], a        ; 2nd line <- all ones

         ENDR

         ; ^ 64 cycles, 35 bytes

         ENDM

TC15:    MACRO

         pop            de              ; * de <- card's data address
         pop            hl              ; hl <- card's VRAM address

         ld             a, $FF

         REPT           8
         ld             [hl+], a        ; 1st line <- all ones
         ld             [hl+], a        ; 2nd line <- all ones
         ENDR

         ; ^ 40 cycles, 20 bytes

         ENDM

TCEND:   MACRO

         ldh            a, [rLY]        ; a <- LCDC Y-Coordinate (144..153)

         inc            b               ; inc CL_TOP
         dec            c               ; dec #/tile to copy
         jr             z, .Exit

         ; ^ 8/7 cycles, 6 bytes

         ld             l, b
         ld             h, COPYLIST >> 8

         ld             e, [hl]
         inc            h
         ld             h, [hl]
         ld             l, e            ; hl <- TILE @ MakeUpBank + Queue

         res            6, [hl]         ; clear COPYLIST-Queue bit

         ld             sp, hl          ; sp -> TILE @ MakeUpBank + Queue

         cp             144             ; is LCDC Y-Coordinate in 0..143 ?
         ret            nc              ; no, so OK to copy freely in VBL

         ; ^ 21/18 cycles, 13 bytes

.HBLOld  ldh            a, [rSTAT]      ; a <- LCDC Status
         and            $03             ; are we in the OLD H-Blank period ?
         jr             z, .HBLOld      ; yes, so wait until we're out of it

.HBLNew  ldh            a, [rSTAT]
         and            $03             ; are we in the NEW H-Blank period ?
         jr             nz, .HBLNew     ; no, so wait until we're in it

         ret

         ; ^ 13 bytes

.Exit

         ld             a, b
         ld             [CL_TOP], a     ; update CL_TOP

         jp             CopyToVRAM_Ret

         ; ^ 7 bytes

         ENDM

TCDEF:   MACRO

\1_P0    DS             $26
\1_C0::  \1
         TCEND
\1_P1    DS             $A2 - ( $26 + \2 )
\1_C1::  \1
         TCEND
\1_P2    DS             $100 - ( $A2 + \2 )

         ENDM

         TCDEF          TC00, 19 + 39
         TCDEF          TC01, 49 + 39
         TCDEF          TC02, 49 + 39
         TCDEF          TC03, 41 + 39
         TCDEF          TC04, 34 + 39
         TCDEF          TC05, 28 + 39
         TCDEF          TC06, 41 + 39
         TCDEF          TC07, 42 + 39
         TCDEF          TC08, 33 + 39
         TCDEF          TC09, 49 + 39
         TCDEF          TC10, 28 + 39
         TCDEF          TC11, 43 + 39
         TCDEF          TC12, 33 + 39
         TCDEF          TC13, 34 + 39
         TCDEF          TC14, 35 + 39
         TCDEF          TC15, 20 + 39

; ---------------------------------------------------------------------------
;             .::** Copy routines for MO_CopyToVRAM **::.
; ---------------------------------------------------------------------------

OFS_PAD  DS             $20             ; bring each routine down 32 bytes
                                        ; (see MO attribute byte #1)

MO_Copy00::

         ; YRES  = 0 (source is 8 rows)
         ; XSIZE = 0 (only 1 card wide)
         ; YSIZE = 0
         ; YFULL = 0 (each row written only once)

         pop            de              ; de <- MO's data address
         pop            hl              ; hl <- MO's VRAM address

         REPT           3               ; do the first 3 (visible) rows

         ld             a, [de]         ; a <- 1st source byte
         inc            e
         ld             [hl+], a        ; 1st row <- 1st source byte

         ld             a, [de]         ; a <- 2nd source byte
         inc            e
         ld             [hl+], a        ; 2nd row <- 2nd source byte

         ENDR                           ; 30 cycles

         ld             a, [de]         ; a <- 1st source byte
         inc            e
         ld             [hl+], a        ; 1st row <- 1st source byte

         ld             a, [de]         ; a <- 2nd source byte
         ld             [hl+], a        ; 2nd row <- 2nd source byte

         xor            a

         REPT           4               ; clear next 4 (visible) rows
         ld             [hl+], a        ; 1st row <- zero
         ld             [hl+], a        ; 2nd row <- zero
         ENDR                           ; 16 cycles

         REPT           7               ; clear next 7 (visible) rows
         ld             [hl+], a        ; 1st row <- zero
         inc            l               ; skip 2nd row (always zero)
         ENDR                           ; 21 cycles

         ld             [hl], a         ; 1st row <- zero

         ; 85 cycles to finish copying, 49 bytes

         inc            b               ; inc ML_TOP
         dec            c               ; dec #/moving objects in queue
         jp             nz, MO_CTV_Loop

         ld             a, b
         ld             [ML_TOP], a     ; update ML_TOP

         jp             CopyToVRAM

M00_PAD  DS             $C3 + 1

MO_Copy01::

         ; YRES  = 0 (source is 8 rows)
         ; XSIZE = 0 (only one card wide)
         ; YSIZE = 0
         ; YFULL = 1 (write each row twice)

         pop            de              ; de <- MO's data address
         pop            hl              ; hl <- MO's VRAM address

         REPT           7               ; do first 7 (visible) rows

         ld             a, [de]         ; a <- source byte
         inc            e

         ld             [hl+], a        ; 1st row <- source byte
         ld             [hl+], a        ; 2nd row <- source byte (color 3)

         ENDR                           ; 49 cycles

         ld             a, [de]         ; a <- source byte

         ld             [hl+], a        ; 1st row <- source byte
         ld             [hl+], a        ; 2nd row <- source byte (color 3)

         xor            a

         REPT           7               ; clear next 7 (visible) rows
         ld             [hl+], a        ; 1st row <- zero
         inc            l               ; skip 2nd row (always zero)
         ENDR                           ; 21 cycles

         ld             [hl], a         ; 1st row <- zero

         ; 85 cycles to finish copying, 49 bytes

         inc            b               ; inc ML_TOP
         dec            c               ; dec #/moving objects in queue
         jp             nz, MO_CTV_Loop

         ld             a, b
         ld             [ML_TOP], a     ; update ML_TOP

         jp             CopyToVRAM

M01_PAD  DS             $C3 + 1

MO_Copy02::

         ; YRES  = 0 (source is 8 rows)
         ; XSIZE = 0 (only one card wide)
         ; YSIZE = 1
         ; YFULL = 0 (write each row four times)

         pop            de              ; de <- MO's data address
         pop            hl              ; hl <- MO's VRAM address

         REPT           4               ; do first 8 (visible) rows

         ld             a, [de]         ; a <- source byte
         inc            e

         ld             [hl+], a        ; 1st row <- source byte
         ld             [hl+], a        ; 2nd row <- source byte (color 3)

         ld             [hl+], a        ; 3rd row <- source byte
         ld             [hl+], a        ; 4th row <- source byte (color 3)

         ENDR                           ; 44 cycles

         REPT           3               ; do next 6 (visible) rows

         ld             a, [de]         ; a <- source byte
         inc            e

         ld             [hl+], a        ; 1st row <- source byte
         inc            l               ; skip 2nd row (always zero)

         ld             [hl+], a        ; 3rd row <- source byte
         inc            l               ; skip 4th row (always zero)

         ENDR                           ; 27 cycles

         ld             a, [de]         ; a <- source byte

         ld             [hl+], a        ; 1st row <- source byte
         inc            l               ; skip 2nd row (always zero)

         ld             [hl+], a        ; 3rd row <- source byte

         ; 84 cycles to finish copying, 48 bytes

         inc            b               ; inc ML_TOP
         dec            c               ; dec #/moving objects in queue
         jp             nz, MO_CTV_Loop

         ld             a, b
         ld             [ML_TOP], a     ; update ML_TOP

         jp             CopyToVRAM

M02_PAD  DS             $C4 + 1

MO_Copy03::

         ; YRES  = 0 (source is 8 rows)
         ; XSIZE = 0 (only one card wide)
         ; YSIZE = 1
         ; YFULL = 1 (write each row eight times)

         pop            de              ; de <- MO's data address
         pop            hl              ; hl <- MO's VRAM address

         REPT           2               ; do first 8 (visible) rows

         ld             a, [de]         ; a <- source byte
         inc            e

         ld             [hl+], a        ; 1st row <- source byte
         ld             [hl+], a        ; 2nd row <- source byte (color 3)

         ld             [hl+], a        ; 3rd row <- source byte
         ld             [hl+], a        ; 4th row <- source byte (color 3)

         ld             [hl+], a        ; 5th row <- source byte
         ld             [hl+], a        ; 6th row <- source byte (color 3)

         ld             [hl+], a        ; 7th row <- source byte
         ld             [hl+], a        ; 8th row <- source byte (color 3)

         ENDR                           ; 38 cycles

         REPT           5               ; do next 20 (visible) rows

         ld             a, [de]         ; a <- source byte
         inc            e

         ld             [hl+], a        ; 1st row <- source byte
         inc            l               ; skip 2nd row (always zero)

         ld             [hl+], a        ; 3rd row <- source byte
         inc            l               ; skip 4th row (always zero)

         ld             [hl+], a        ; 5th row <- source byte
         inc            l               ; skip 6th row (always zero)

         ld             [hl+], a        ; 7th row <- source byte
         inc            l               ; skip 8th row (always zero)

         ENDR                           ; 75 cycles

         ld             a, [de]         ; a <- source byte

         ld             [hl+], a        ; 1st row <- source byte
         inc            l               ; skip 2nd row (always zero)

         ld             [hl+], a        ; 3rd row <- source byte
         inc            l               ; skip 4th row (always zero)

         ld             [hl+], a        ; 5th row <- source byte
         inc            l               ; skip 6th row (always zero)

         ld             [hl+], a        ; 7th row <- source byte

         ; 132 cycles to finish copying, 80 bytes

         inc            b               ; inc ML_TOP
         dec            c               ; dec #/moving objects in queue
         jp             nz, MO_CTV_Loop

         ld             a, b
         ld             [ML_TOP], a     ; update ML_TOP

         jp             CopyToVRAM

M03_PAD  DS             $A4 + 1

MO_Copy04::

         ; YRES  = 0 (source is 8 rows)
         ; XSIZE = 1 (two cards wide)
         ; YSIZE = 0
         ; YFULL = 0 (write each row one time)

         pop            hl              ; hl <- MO's data address
         pop            de              ; de <- MO's VRAM address

         ld             sp, Save_BC + 2
         push           bc              ; [Save_BC] <- bc

         ld             sp, hl          ; sp <- MO's data address
         ld             l, e
         ld             h, d            ; hl <- MO's VRAM address

         ; handle sprite #0 (upper left-hand corner of the image)

         ld             b, DoubleNybble_Hi >> 8

         REPT           4               ; do 4 (visible) rows

         pop            de              ; d <- 2nd source byte, e <- 1st byte

         ld             c, e            ; c <- 1st source byte
         ld             a, [bc]         ; a <- HIGH nybble "doubled"
         ld             [hl+], a        ; 1st row <- 1st source byte (dbl'd)

         ld             c, d            ; c <- 2nd source byte
         ld             a, [bc]         ; a <- HIGH nybble "doubled"
         ld             [hl+], a        ; 2nd row <- 2nd source byte (dbl'd)

         ENDR                           ; 52 cycles

         xor            a

         REPT           4               ; clear next 4 (visible) rows
         ld             [hl+], a        ; 1st row <- zero
         ld             [hl+], a        ; 2nd row <- zero
         ENDR

         REPT           7               ; clear next 7 (visible) rows
         ld             [hl+], a        ; 1st row <- zero
         inc            l               ; skip 2nd row (always zero)
         ENDR

         ld             [hl+], a        ; 1st row <- zero

         ld             de, 16 * 2 + 1
         add            hl, de          ; skip sprite #1 (lower left-hand)

         add            sp, -8          ; re-position source at top of card

         ; handle sprite #2 (upper right-hand corner of the image)

         dec            b               ; b = DoubleNybble_Lo >> 8

         REPT           4               ; do 4 (visable) rows

         pop            de              ; d <- 2nd source byte, e <- 1st byte

         ld             c, e            ; c <- 1st source byte
         ld             a, [bc]         ; a <- HIGH nybble "doubled"
         ld             [hl+], a        ; 1st row <- 1st source byte (dbl'd)

         ld             c, d            ; c <- 2nd source byte
         ld             a, [bc]         ; a <- HIGH nybble "doubled"
         ld             [hl+], a        ; 2nd row <- 2nd source byte (dbl'd)

         ENDR

         xor            a

         REPT           4               ; clear next 4 (visible) rows
         ld             [hl+], a        ; 1st row <- zero
         ld             [hl+], a        ; 2nd row <- zero
         ENDR

         REPT           7               ; clear next 7 (visible) rows
         ld             [hl+], a        ; 1st row <- zero
         inc            l               ; skip 2nd row (always zero)
         ENDR

         ld             [hl+], a        ; 1st row <- zero

         ; 213 cycles to finish copying, 122 bytes

         ld             sp, Save_BC
         pop            bc              ; bc <- [Save_BC]

         inc            b               ; inc ML_TOP
         dec            c               ; dec #/moving objects in queue
         jp             nz, MO_CTV_Loop

         ld             a, b
         ld             [ML_TOP], a     ; update ML_TOP

         jp             CopyToVRAM

M04_PAD  DS             $76 + 1

MO_Copy05::

         ; YRES  = 0 (source is 8 rows)
         ; XSIZE = 1 (two cards wide)
         ; YSIZE = 0
         ; YFULL = 1 (write each row two times)

         pop            hl              ; hl <- MO's data address
         pop            de              ; de <- MO's VRAM address

         ld             sp, Save_BC + 2
         push           bc              ; [Save_BC] <- bc

         ld             sp, hl          ; sp <- MO's data address
         ld             l, e
         ld             h, d            ; hl <- MO's VRAM address

         ; handle sprite #0 (upper left-hand corner of the image)

         ld             b, DoubleNybble_Hi >> 8

         REPT           4               ; do 8 (visible) rows

         pop            de              ; d <- 2nd source byte, e <- 1st byte

         ld             c, e            ; c <- 1st source byte
         ld             a, [bc]         ; a <- HIGH nybble "doubled"
         ld             [hl+], a        ; 1st row <- 1st source byte (dbl'd)
         ld             [hl+], a        ; 2nd row <- 1st source byte (dbl'd)

         ld             c, d            ; c <- 2nd source byte
         ld             a, [bc]         ; a <- HIGH nybble "doubled"
         ld             [hl+], a        ; 3rd row <- 2nd source byte (dbl'd)
         ld             [hl+], a        ; 4th row <- 2nd source byte (dbl'd)

         ENDR                           ; 68 cycles

         xor            a

         REPT           7               ; clear next 7 (visible) rows
         ld             [hl+], a        ; 1st row <- zero
         inc            l               ; skip 2nd row (always zero)
         ENDR

         ld             [hl+], a        ; 1st row <- zero

         ld             de, 16 * 2 + 1
         add            hl, de          ; skip sprite #1 (lower left-hand)

         add            sp, -8          ; re-position source at top of card

         ; handle sprite #2 (upper right-hand corner of the image)

         dec            b               ; b = DoubleNybble_Lo >> 8

         REPT           4               ; do 8 (visible) rows

         pop            de              ; d <- 2nd source byte, e <- 1st byte

         ld             c, e            ; c <- 1st source byte
         ld             a, [bc]         ; a <- HIGH nybble "doubled"
         ld             [hl+], a        ; 1st row <- 1st source byte (dbl'd)
         ld             [hl+], a        ; 2nd row <- 1st source byte (dbl'd)

         ld             c, d            ; c <- 2nd source byte
         ld             a, [bc]         ; a <- HIGH nybble "doubled"
         ld             [hl+], a        ; 3rd row <- 2nd source byte (dbl'd)
         ld             [hl+], a        ; 4th row <- 2nd source byte (dbl'd)

         ENDR

         xor            a

         REPT           7               ; clear next 7 (visible) rows
         ld             [hl+], a        ; 1st row <- zero
         inc            l               ; skip 2nd row (always zero)
         ENDR

         ld             [hl+], a        ; 1st row <- zero

         ; 213 cycles to finish copying, 122 bytes

         ld             sp, Save_BC
         pop            bc              ; bc <- [Save_BC]

         inc            b               ; inc ML_TOP
         dec            c               ; dec #/moving objects in queue
         jp             nz, MO_CTV_Loop

         ld             a, b
         ld             [ML_TOP], a     ; update ML_TOP

         jp             CopyToVRAM

M05_PAD  DS             $76 + 1

MO_Copy06::

         ; YRES  = 0 (source is 8 rows)
         ; XSIZE = 1 (two cards wide)
         ; YSIZE = 1
         ; YFULL = 0 (write each row four times)

         pop            hl              ; hl <- MO's data address
         pop            de              ; de <- MO's VRAM address

         ld             sp, Save_BC + 2
         push           bc              ; [Save_BC] <- bc

         ld             sp, hl          ; sp <- MO's data address
         ld             l, e
         ld             h, d            ; hl <- MO's VRAM address

         ; handle sprite #0 (upper left-hand corner of the image)

         ld             b, DoubleNybble_Hi >> 8

         REPT           2               ; do first 8 (visible) rows

         pop            de              ; d <- 2nd source byte, e <- 1st byte

         ld             c, e            ; c <- 1st source byte
         ld             a, [bc]         ; a <- HIGH nybble "doubled"
         ld             [hl+], a        ; 1st row <- 1st source byte (dbl'd)
         ld             [hl+], a        ; 2nd row <- 1st source byte (dbl'd)
         ld             [hl+], a        ; 3rd row <- 1st source byte (dbl'd)
         ld             [hl+], a        ; 4th row <- 1st source byte (dbl'd)

         ld             c, d            ; c <- 2nd source byte
         ld             a, [bc]         ; a <- HIGH nybble "doubled"
         ld             [hl+], a        ; 5th row <- 2nd source byte (dbl'd)
         ld             [hl+], a        ; 6th row <- 2nd source byte (dbl'd)
         ld             [hl+], a        ; 7th row <- 2nd source byte (dbl'd)
         ld             [hl+], a        ; 8th row <- 2nd source byte (dbl'd)

         ENDR

         pop            de              ; d <- 2nd source byte, e <- 1st byte

         ld             c, e            ; c <- 1st source byte
         ld             a, [bc]         ; a <- HIGH nybble "doubled"
         ld             [hl+], a        ; 1st row <- 1st source byte (dbl'd)
         inc            l               ; skip 2nd row (always zero)
         ld             [hl+], a        ; 3rd row <- 1st source byte (dbl'd)
         inc            l               ; skip 4th row (always zero)

         ld             c, d            ; c <- 2nd source byte
         ld             a, [bc]         ; a <- HIGH nybble "doubled"
         ld             [hl+], a        ; 5th row <- 2nd source byte (dbl'd)
         inc            l               ; skip 6th row (always zero)
         ld             [hl+], a        ; 7th row <- 2nd source byte (dbl'd)
         inc            l               ; skip 8th row (always zero)

         pop            de              ; d <- 2nd source byte, e <- 1st byte

         ld             c, e            ; c <- 1st source byte
         ld             a, [bc]         ; a <- HIGH nybble "doubled"
         ld             [hl+], a        ; 1st row <- 1st source byte (dbl'd)
         inc            l               ; skip 2nd row (always zero)
         ld             [hl+], a        ; 3rd row <- 1st source byte (dbl'd)
         inc            l               ; skip 4th row (always zero)

         ld             c, d            ; c <- 2nd source byte
         ld             a, [bc]         ; a <- HIGH nybble "doubled"
         ld             [hl+], a        ; 5th row <- 2nd source byte (dbl'd)
         inc            l               ; skip 6th row (always zero)
         ld             [hl+], a        ; 7th row <- 2nd source byte (dbl'd)

         ld             de, 16 * 2 + 1
         add            hl, de          ; skip sprite #1 (lower left-hand)

         add            sp, -8          ; re-position source at top of card

         ; handle sprite #2 (upper right-hand corner of the image)

         dec            b               ; b = DoubleNybble_Lo >> 8

         REPT           2               ; do first 8 (visible) rows

         pop            de              ; d <- 2nd source byte, e <- 1st byte

         ld             c, e            ; c <- 1st source byte
         ld             a, [bc]         ; a <- LOW nybble "doubled"
         ld             [hl+], a        ; 1st row <- 1st source byte (dbl'd)
         ld             [hl+], a        ; 2nd row <- 1st source byte (dbl'd)
         ld             [hl+], a        ; 3rd row <- 1st source byte (dbl'd)
         ld             [hl+], a        ; 4th row <- 1st source byte (dbl'd)

         ld             c, d            ; c <- 2nd source byte
         ld             a, [bc]         ; a <- LOW nybble "doubled"
         ld             [hl+], a        ; 5th row <- 2nd source byte (dbl'd)
         ld             [hl+], a        ; 6th row <- 2nd source byte (dbl'd)
         ld             [hl+], a        ; 7th row <- 2nd source byte (dbl'd)
         ld             [hl+], a        ; 8th row <- 2nd source byte (dbl'd)

         ENDR

         pop            de              ; d <- 2nd source byte, e <- 1st byte

         ld             c, e            ; c <- 1st source byte
         ld             a, [bc]         ; a <- LOW nybble "doubled"
         ld             [hl+], a        ; 1st row <- 1st source byte (dbl'd)
         inc            l               ; skip 2nd row (always zero)
         ld             [hl+], a        ; 3rd row <- 1st source byte (dbl'd)
         inc            l               ; skip 4th row (always zero)

         ld             c, d            ; c <- 2nd source byte
         ld             a, [bc]         ; a <- LOW nybble "doubled"
         ld             [hl+], a        ; 5th row <- 2nd source byte (dbl'd)
         inc            l               ; skip 6th row (always zero)
         ld             [hl+], a        ; 7th row <- 2nd source byte (dbl'd)
         inc            l               ; skip 8th row (always zero)

         pop            de              ; d <- 2nd source byte, e <- 1st byte

         ld             c, e            ; c <- 1st source byte
         ld             a, [bc]         ; a <- LOW nybble "doubled"
         ld             [hl+], a        ; 1st row <- 1st source byte (dbl'd)
         inc            l               ; skip 2nd row (always zero)
         ld             [hl+], a        ; 3rd row <- 1st source byte (dbl'd)
         inc            l               ; skip 4th row (always zero)

         ld             c, d            ; c <- 2nd source byte
         ld             a, [bc]         ; a <- LOW nybble "doubled"
         ld             [hl+], a        ; 5th row <- 2nd source byte (dbl'd)
         inc            l               ; skip 6th row (always zero)
         ld             [hl+], a        ; 7th row <- 2nd source byte (dbl'd)

         ; 211 cycles to finish copying, 120 bytes

         ld             sp, Save_BC
         pop            bc              ; bc <- [Save_BC]

         inc            b               ; inc ML_TOP
         dec            c               ; dec #/moving objects in queue
         jp             nz, MO_CTV_Loop

         ld             a, b
         ld             [ML_TOP], a     ; update ML_TOP

         jp             CopyToVRAM

M06_PAD  DS             $78 + 1

MO_Copy07::

         ; YRES  = 0 (source is 8 rows)
         ; XSIZE = 1 (two cards wide)
         ; YSIZE = 1
         ; YFULL = 1 (write each row eight times)

         pop            hl              ; hl <- MO's data address
         pop            de              ; de <- MO's VRAM address

         ld             sp, Save_BC + 2
         push           bc              ; [Save_BC] <- bc

         ld             sp, hl          ; sp <- MO's data address
         ld             l, e
         ld             h, d            ; hl <- MO's VRAM address

         ; handle sprite #0 (upper left-hand corner of the image)

         ld             b, DoubleNybble_Hi >> 8

         pop            de              ; d <- 2nd source byte, e <- 1st byte

         ld             c, e            ; c <- 1st source byte
         ld             a, [bc]         ; a <- HIGH nybble "doubled"
         ld             [hl+], a        ; 1st row <- 1st source byte (dbl'd)
         ld             [hl+], a        ; 2nd row <- 1st source byte (dbl'd)
         ld             [hl+], a        ; 3rd row <- 1st source byte (dbl'd)
         ld             [hl+], a        ; 4th row <- 1st source byte (dbl'd)
         ld             [hl+], a        ; 5th row <- 1st source byte (dbl'd)
         ld             [hl+], a        ; 6th row <- 1st source byte (dbl'd)
         ld             [hl+], a        ; 7th row <- 1st source byte (dbl'd)
         ld             [hl+], a        ; 8th row <- 1st source byte (dbl'd)

         ld             c, d            ; c <- 2nd source byte
         ld             a, [bc]         ; a <- HIGH nybble "doubled"
         ld             [hl+], a        ; 9th row <- 2nd source byte (dbl'd)
         ld             [hl+], a        ; 10th row <- 2nd source byte (dbl'd)
         ld             [hl+], a        ; 11th row <- 2nd source byte (dbl'd)
         ld             [hl+], a        ; 12th row <- 2nd source byte (dbl'd)
         ld             [hl+], a        ; 13th row <- 2nd source byte (dbl'd)
         ld             [hl+], a        ; 14th row <- 2nd source byte (dbl'd)
         ld             [hl+], a        ; 15th row <- 2nd source byte (dbl'd)
         ld             [hl+], a        ; 16th row <- 2nd source byte (dbl'd)

         REPT           3               ; do last 24 (visible) rows

         pop            de              ; d <- 2nd source byte, e <- 1st byte

         ld             c, e            ; c <- 1st source byte
         ld             a, [bc]         ; a <- HIGH nybble "doubled"
         ld             [hl+], a        ; 1st row <- 1st source byte (dbl'd)
         inc            l               ; skip 2nd row (always zero)
         ld             [hl+], a        ; 3rd row <- 1st source byte (dbl'd)
         inc            l               ; skip 4th row (always zero)
         ld             [hl+], a        ; 5th row <- 1st source byte (dbl'd)
         inc            l               ; skip 6th row (always zero)
         ld             [hl+], a        ; 7th row <- 1st source byte (dbl'd)
         inc            l               ; skip 8th row (always zero)

         ld             c, d            ; c <- 2nd source byte
         ld             a, [bc]         ; a <- HIGH nybble "doubled"
         ld             [hl+], a        ; 9th row <- 2nd source byte (dbl'd)
         inc            l               ; skip 10th row (always zero)
         ld             [hl+], a        ; 11th row <- 2nd source byte (dbl'd)
         inc            l               ; skip 12th row (always zero)
         ld             [hl+], a        ; 13th row <- 2nd source byte (dbl'd)
         inc            l               ; skip 14th row (always zero)
         ld             [hl+], a        ; 15th row <- 2nd source byte (dbl'd)
         inc            l               ; skip 16th row (always zero)

         ENDR                           ; 99 cycles

         add            sp, -8          ; re-position source at top of card

         ; handle sprite #2 (upper right-hand corner of the image)

         dec            b               ; b = DoubleNybble_Lo >> 8

         pop            de              ; d <- 2nd source byte, e <- 1st byte

         ld             c, e            ; c <- 1st source byte
         ld             a, [bc]         ; a <- LOW nybble "doubled"
         ld             [hl+], a        ; 1st row <- 1st source byte (dbl'd)
         ld             [hl+], a        ; 2nd row <- 1st source byte (dbl'd)
         ld             [hl+], a        ; 3rd row <- 1st source byte (dbl'd)
         ld             [hl+], a        ; 4th row <- 1st source byte (dbl'd)
         ld             [hl+], a        ; 5th row <- 1st source byte (dbl'd)
         ld             [hl+], a        ; 6th row <- 1st source byte (dbl'd)
         ld             [hl+], a        ; 7th row <- 1st source byte (dbl'd)
         ld             [hl+], a        ; 8th row <- 1st source byte (dbl'd)

         ld             c, d            ; c <- 2nd source byte
         ld             a, [bc]         ; a <- LOW nybble "doubled"
         ld             [hl+], a        ; 9th row <- 2nd source byte (dbl'd)
         ld             [hl+], a        ; 10th row <- 2nd source byte (dbl'd)
         ld             [hl+], a        ; 11th row <- 2nd source byte (dbl'd)
         ld             [hl+], a        ; 12th row <- 2nd source byte (dbl'd)
         ld             [hl+], a        ; 13th row <- 2nd source byte (dbl'd)
         ld             [hl+], a        ; 14th row <- 2nd source byte (dbl'd)
         ld             [hl+], a        ; 15th row <- 2nd source byte (dbl'd)
         ld             [hl+], a        ; 16th row <- 2nd source byte (dbl'd)

         REPT           2               ; do next 16 (visible) rows

         pop            de              ; d <- 2nd source byte, e <- 1st byte

         ld             c, e            ; c <- 1st source byte
         ld             a, [bc]         ; a <- HIGH nybble "doubled"
         ld             [hl+], a        ; 1st row <- 1st source byte (dbl'd)
         inc            l               ; skip 2nd row (always zero)
         ld             [hl+], a        ; 3rd row <- 1st source byte (dbl'd)
         inc            l               ; skip 4th row (always zero)
         ld             [hl+], a        ; 5th row <- 1st source byte (dbl'd)
         inc            l               ; skip 6th row (always zero)
         ld             [hl+], a        ; 7th row <- 1st source byte (dbl'd)
         inc            l               ; skip 8th row (always zero)

         ld             c, d            ; c <- 2nd source byte
         ld             a, [bc]         ; a <- HIGH nybble "doubled"
         ld             [hl+], a        ; 9th row <- 2nd source byte (dbl'd)
         inc            l               ; skip 10th row (always zero)
         ld             [hl+], a        ; 11th row <- 2nd source byte (dbl'd)
         inc            l               ; skip 12th row (always zero)
         ld             [hl+], a        ; 13th row <- 2nd source byte (dbl'd)
         inc            l               ; skip 14th row (always zero)
         ld             [hl+], a        ; 15th row <- 2nd source byte (dbl'd)
         inc            l               ; skip 16th row (always zero)

         ENDR                           ; 66 cycles

         pop            de              ; d <- 2nd source byte, e <- 1st byte

         ld             c, e            ; c <- 1st source byte
         ld             a, [bc]         ; a <- LOW nybble "doubled"
         ld             [hl+], a        ; 1st row <- 1st source byte (dbl'd)
         inc            l               ; skip 2nd row (always zero)
         ld             [hl+], a        ; 3rd row <- 1st source byte (dbl'd)
         inc            l               ; skip 4th row (always zero)
         ld             [hl+], a        ; 5th row <- 1st source byte (dbl'd)
         inc            l               ; skip 6th row (always zero)
         ld             [hl+], a        ; 7th row <- 1st source byte (dbl'd)
         inc            l               ; skip 8th row (always zero)

         ld             c, d            ; c <- 2nd source byte
         ld             a, [bc]         ; a <- LOW nybble "doubled"
         ld             [hl+], a        ; 9th row <- 2nd source byte (dbl'd)
         inc            l               ; skip 10th row (always zero)
         ld             [hl+], a        ; 11th row <- 2nd source byte (dbl'd)
         inc            l               ; skip 12th row (always zero)
         ld             [hl+], a        ; 13th row <- 2nd source byte (dbl'd)
         inc            l               ; skip 14th row (always zero)
         ld             [hl+], a        ; 15th row <- 2nd source byte (dbl'd)

         ; 287 cycles to finish copying, 197 bytes

         ld             sp, Save_BC
         pop            bc              ; bc <- [Save_BC]

         inc            b               ; inc ML_TOP
         dec            c               ; dec #/moving objects in queue
         jp             nz, MO_CTV_Loop

         ld             a, b
         ld             [ML_TOP], a     ; update ML_TOP

         jp             CopyToVRAM

M07_PAD  DS             $3B + 1

MO_Copy08::

         ; YRES  = 1 (source is 16 rows)
         ; XSIZE = 0 (only one card wide)
         ; YSIZE = 0
         ; YFULL = 0 (write each row one time)

         pop            de              ; de <- MO's data address
         pop            hl              ; hl <- MO's VRAM address

         REPT           7               ; do 1st 7 (visible) rows

         ld             a, [de]         ; a <- 1st source byte
         inc            e
         ld             [hl+], a        ; 1st row <- 1st source byte

         ld             a, [de]         ; a <- 2nd source byte
         inc            e
         ld             [hl+], a        ; 2nd row <- 2nd source byte

         ENDR                           ; 70 cycles

         ld             a, [de]         ; a <- 1st source byte
         inc            e
         ld             [hl+], a        ; 1st row <- 1st source byte

         ld             a, [de]         ; a <- 2nd source byte
         ld             [hl+], a        ; 2nd row <- 2nd source byte

         xor            a

         REPT           7               ; clear next 7 (visible) rows
         ld             [hl+], a        ; 1st row <- zero
         inc            l               ; skip 2nd row (always zero)
         ENDR

         ld             [hl+], a        ; 1st row <- zero

         ; 109 cycles to finish copying, 65 bytes

         inc            b               ; inc ML_TOP
         dec            c               ; dec #/moving objects in queue
         jp             nz, MO_CTV_Loop

         ld             a, b
         ld             [ML_TOP], a     ; update ML_TOP

         jp             CopyToVRAM

M08_PAD  DS             $B3 + 1

MO_Copy09::

         ; YRES  = 1 (source is 16 rows)
         ; XSIZE = 0 (only one card wide)
         ; YSIZE = 0
         ; YFULL = 1 (write each row two times)

         pop            de              ; de <- MO's data address
         pop            hl              ; hl <- MO's VRAM address

         REPT           8               ; do 1st 8 (visible) rows

         ld             a, [de]         ; a <- source byte
         inc            e
         ld             [hl+], a        ; 1st row <- source byte
         ld             [hl+], a        ; 2nd row <- source byte (color 3)

         ENDR

         REPT           7               ; do next 7 (visible) rows

         ld             a, [de]         ; a <- source byte
         inc            e
         ld             [hl+], a        ; 1st row <- source byte
         inc            l               ; skip 2nd row (always zero)

         ENDR

         ld             a, [de]         ; a <- source byte
         ld             [hl+], a        ; 1st row <- source byte

         ; 108 cycles to finish copying, 64 bytes

         inc            b               ; inc ML_TOP
         dec            c               ; dec #/moving objects in queue
         jp             nz, MO_CTV_Loop

         ld             a, b
         ld             [ML_TOP], a     ; update ML_TOP

         jp             CopyToVRAM

M09_PAD  DS             $B4 + 1

MO_Copy10::

         ; YRES  = 1 (copy 16 rows)
         ; XSIZE = 0 (only one card wide)
         ; YSIZE = 1
         ; YFULL = 0 (write each row four times)

         pop            de              ; de <- MO's data address
         pop            hl              ; hl <- MO's VRAM address

         REPT           4               ; do 1st 8 (visible) rows

         ld             a, [de]         ; a <- source byte
         inc            e
         ld             [hl+], a        ; 1st row <- source byte
         ld             [hl+], a        ; 2nd row <- source byte (color 3)
         ld             [hl+], a        ; 3rd row <- source byte
         ld             [hl+], a        ; 4th row <- source byte (color 3)

         ENDR                           ; 88 cycles

         REPT           11              ; do next 22 (visible) rows

         ld             a, [de]         ; a <- source byte
         inc            e
         ld             [hl+], a        ; 1st row <- source byte
         inc            l               ; skip 2nd row (always zero)
         ld             [hl+], a        ; 3rd row <- source byte
         inc            l               ; skip 4th row (always zero)

         ENDR                           ; 63 cycles

         ld             a, [de]         ; a <- source byte
         ld             [hl+], a        ; 1st row <- source byte
         inc            l               ; skip 2nd row (always zero)
         ld             [hl+], a        ; 3rd row <- source byte

         ; 164 cycles to finish copying, 96 bytes

         inc            b               ; inc ML_TOP
         dec            c               ; dec #/moving objects in queue
         jp             nz, MO_CTV_Loop

         ld             a, b
         ld             [ML_TOP], a     ; update ML_TOP

         jp             CopyToVRAM

M10_PAD  DS             $94 + 1

MO_Copy11::

         ; YRES  = 1 (source is 16 rows)
         ; XSIZE = 0 (only one card wide)
         ; YSIZE = 1
         ; YFULL = 1 (write each row eight times)

         pop            de              ; de <- MO's data address
         pop            hl              ; hl <- MO's VRAM address

         REPT           2               ; do 1st 8 (visible) rows

         ld             a, [de]         ; a <- source byte
         inc            e
         ld             [hl+], a        ; 1st row <- source byte
         ld             [hl+], a        ; 2nd row <- source byte (color 3)
         ld             [hl+], a        ; 3rd row <- source byte
         ld             [hl+], a        ; 4th row <- source byte (color 3)
         ld             [hl+], a        ; 5th row <- source byte
         ld             [hl+], a        ; 6th row <- source byte (color 3)
         ld             [hl+], a        ; 7th row <- source byte
         ld             [hl+], a        ; 8th row <- source byte (color 3)

         ENDR                           ; 38 cycles

         REPT           5               ; do next 20 (visible) rows

         ld             a, [de]         ; a <- source byte
         inc            e
         ld             [hl+], a        ; 1st row <- source byte
         inc            l               ; skip 2nd row (always zero)
         ld             [hl+], a        ; 3rd row <- source byte
         inc            l               ; skip 4th row (always zero)
         ld             [hl+], a        ; 5th row <- source byte
         inc            l               ; skip 6th row (always zero)
         ld             [hl+], a        ; 7th row <- source byte
         inc            l               ; skip 8th row (always zero)

         ENDR                           ; 75 cycles

         ld             a, [de]         ; a <- source byte
         inc            e
         ld             [hl+], a        ; 1st row <- source byte
         inc            l               ; skip 2nd row (always zero)
         ld             [hl+], a        ; 3rd row <- source byte
         inc            l               ; skip 4th row (always zero)
         ld             [hl+], a        ; 5th row <- source byte
         inc            l               ; skip 6th row (always zero)
         ld             [hl+], a        ; 7th row <- source byte

         ; 133 cycles to finish copying, 81 bytes

         inc            b               ; inc ML_TOP
         dec            c               ; dec #/moving objects in queue
         jp             nz, MO_CTV_Loop

         ld             a, b
         ld             [ML_TOP], a     ; update ML_TOP

         jp             CopyToVRAM

M11_PAD  DS             $A3 + 1

MO_Copy12::

         ; YRES  = 1 (copy 16 rows)
         ; XSIZE = 1 (two cards wide)
         ; YSIZE = 0
         ; YFULL = 0 (write each row one time)

         pop            hl              ; hl <- MO's data address
         pop            de              ; de <- MO's VRAM address

         ld             sp, Save_BC + 2
         push           bc              ; [Save_BC] <- bc

         ld             sp, hl          ; sp <- MO's data address
         ld             l, e
         ld             h, d            ; hl <- MO's VRAM address

         ld             b, DoubleNybble_Hi >> 8

         REPT           8               ; do 8 (visible) rows

         pop            de              ; d <- 2nd source byte, e <- 1st byte

         ld             c, e            ; c <- 1st source byte
         ld             a, [bc]         ; a <- HIGH nybble "doubled"
         ld             [hl+], a        ; 1st row <- 1st source byte (dbl'd)

         ld             c, d            ; c <- 2nd source byte
         ld             a, [bc]         ; a <- HIGH nybble "doubled"
         ld             [hl+], a        ; 2nd row <- 2nd source byte (dbl'd)

         ENDR                           ; 104 cycles

         xor            a

         REPT           7               ; clear next 7 (visible) rows
         ld             [hl+], a        ; 1st row <- zero
         inc            l               ; skip 2nd (always zero)
         ENDR

         ld             [hl+], a        ; 1st row <- zero

         ld             de, 16 * 2 + 1
         add            hl, de          ; skip sprite #1 (lower left corner)

         add            sp, -16         ; position source at top of 1st card

         dec            b               ; b = DoubleNybble_Lo >> 8

         REPT           8               ; do 8 (visible) rows

         pop            de              ; d <- 2nd source byte, e <- 1st byte

         ld             c, e            ; c <- 1st source byte
         ld             a, [bc]         ; a <- LOW nybble "doubled"
         ld             [hl+], a        ; 1st row <- 1st source byte (dbl'd)

         ld             c, d            ; c <- 2nd source byte
         ld             a, [bc]         ; a <- LOW nybble "doubled"
         ld             [hl+], a        ; 2nd row <- 2nd source byte (dbl'd)

         ENDR

         xor            a

         REPT           7               ; clear next 7 (visible) rows
         ld             [hl+], a        ; 1st row <- zero
         inc            l               ; skip 2nd (always zero)
         ENDR

         ld             [hl+], a        ; 1st row <- zero

         ; 285 cycles to finish copying, 162 bytes

         ld             sp, Save_BC
         pop            bc              ; bc <- [Save_BC]

         inc            b               ; inc ML_TOP
         dec            c               ; dec #/moving objects in queue
         jp             nz, MO_CTV_Loop

         ld             a, b
         ld             [ML_TOP], a     ; update ML_TOP

         jp             CopyToVRAM

M12_PAD  DS             $4E + 1

MO_Copy13::

         ; YRES  = 1 (source is 16 rows)
         ; XSIZE = 1 (two cards wide)
         ; YSIZE = 0
         ; YFULL = 1 (write each row two times)

         pop            hl              ; hl <- MO's data address
         pop            de              ; de <- MO's VRAM address

         ld             sp, Save_BC + 2
         push           bc              ; [Save_BC] <- bc

         ld             sp, hl          ; sp <- MO's data address
         ld             l, e
         ld             h, d            ; hl <- MO's VRAM address

         ld             b, DoubleNybble_Hi >> 8

         REPT           4               ; do 1st 8 (visible) rows

         pop            de              ; d <- 2nd source byte, e <- 1st byte

         ld             c, e            ; c <- 1st source byte
         ld             a, [bc]         ; a <- HIGH nybble "doubled"
         ld             [hl+], a        ; 1st row <- 1st source byte (dbl'd)
         ld             [hl+], a        ; 2nd row <- 1st source byte (dbl'd)

         ld             c, d            ; c <- 2nd source byte
         ld             a, [bc]         ; a <- HIGH nybble "doubled"
         ld             [hl+], a        ; 3rd row <- 2nd source byte (dbl'd)
         ld             [hl+], a        ; 4th row <- 2nd source byte (dbl'd)

         ENDR                           ; 68 cycles

         REPT           3               ; do next 6 (visible) rows

         pop            de              ; d <- 2nd source byte, e <- 1st byte

         ld             c, e            ; c <- 1st source byte
         ld             a, [bc]         ; a <- HIGH nybble "doubled"
         ld             [hl+], a        ; 1st row <- 1st source byte (dbl'd)
         inc            l               ; skip 2nd row (always zero)

         ld             c, d            ; c <- 2nd source byte
         ld             a, [bc]         ; a <- HIGH nybble "doubled"
         ld             [hl+], a        ; 3rd row <- 2nd source byte (dbl'd)
         inc            l               ; skip 4th row (always zero)

         ENDR                           ; 45 cycles

         pop            de              ; d <- 2nd source byte, e <- 1st byte

         ld             c, e            ; c <- 1st source byte
         ld             a, [bc]         ; a <- HIGH nybble "doubled"
         ld             [hl+], a        ; 1st row <- 1st source byte (dbl'd)
         inc            l               ; skip 2nd row (always zero)

         ld             c, d            ; c <- 2nd source byte
         ld             a, [bc]         ; a <- HIGH nybble "doubled"
         ld             [hl+], a        ; 3rd row <- 2nd source byte (dbl'd)

         ld             de, 16 * 2 + 1
         add            hl, de          ; skip sprite #1 (lower left corner)

         add            sp, -16         ; position source at top of 1st card

         dec            b               ; b = DoubleNybble_Lo >> 8

         REPT           4               ; do 1st 8 (visible) rows

         pop            de              ; d <- 2nd source byte, e <- 1st byte

         ld             c, e            ; c <- 1st source byte
         ld             a, [bc]         ; a <- HIGH nybble "doubled"
         ld             [hl+], a        ; 1st row <- 1st source byte (dbl'd)
         ld             [hl+], a        ; 2nd row <- 1st source byte (dbl'd)

         ld             c, d            ; c <- 2nd source byte
         ld             a, [bc]         ; a <- HIGH nybble "doubled"
         ld             [hl+], a        ; 3rd row <- 2nd source byte (dbl'd)
         ld             [hl+], a        ; 4th row <- 2nd source byte (dbl'd)

         ENDR                           ; 68 cycles

         REPT           3               ; do next 6 (visible) rows

         pop            de              ; d <- 2nd source byte, e <- 1st byte

         ld             c, e            ; c <- 1st source byte
         ld             a, [bc]         ; a <- HIGH nybble "doubled"
         ld             [hl+], a        ; 1st row <- 1st source byte (dbl'd)
         inc            l               ; skip 2nd row (always zero)

         ld             c, d            ; c <- 2nd source byte
         ld             a, [bc]         ; a <- HIGH nybble "doubled"
         ld             [hl+], a        ; 3rd row <- 2nd source byte (dbl'd)
         inc            l               ; skip 4th row (always zero)

         ENDR                           ; 45 cycles

         pop            de              ; d <- 2nd source byte, e <- 1st byte

         ld             c, e            ; c <- 1st source byte
         ld             a, [bc]         ; a <- HIGH nybble "doubled"
         ld             [hl+], a        ; 1st row <- 1st source byte (dbl'd)
         inc            l               ; skip 2nd row (always zero)

         ld             c, d            ; c <- 2nd source byte
         ld             a, [bc]         ; a <- HIGH nybble "doubled"
         ld             [hl+], a        ; 3rd row <- 2nd source byte (dbl'd)

         ; 283 cycles to finish copying, 160 bytes

         ld             sp, Save_BC
         pop            bc              ; bc <- [Save_BC]

         inc            b               ; inc ML_TOP
         dec            c               ; dec #/moving objects in queue
         jp             nz, MO_CTV_Loop

         ld             a, b
         ld             [ML_TOP], a     ; update ML_TOP

         jp             CopyToVRAM

M13_PAD  DS             $50 + 1

MO_Copy14::

         ; YRES  = 1 (source is 16 rows)
         ; XSIZE = 1 (two cards wide)
         ; YSIZE = 1
         ; YFULL = 0 (write each row four times)

         pop            hl              ; hl <- MO's data address
         pop            de              ; de <- MO's VRAM address

         ld             sp, Save_BC + 2
         push           bc              ; [Save_BC] <- bc

         ld             sp, hl          ; sp <- MO's data address
         ld             l, e
         ld             h, d            ; hl <- MO's VRAM address

         ld             b, DoubleNybble_Hi >> 8

         REPT           2               ; do 1st 8 (visible) rows

         pop            de              ; d <- 2nd source byte, e <- 1st byte

         ld             c, e            ; c <- 1st source byte
         ld             a, [bc]         ; a <- HIGH nybble "doubled"
         ld             [hl+], a        ; 1st row <- 1st source byte (dbl'd)
         ld             [hl+], a        ; 2nd row <- 1st source byte (dbl'd)
         ld             [hl+], a        ; 3rd row <- 1st source byte (dbl'd)
         ld             [hl+], a        ; 4th row <- 1st source byte (dbl'd)

         ld             c, d            ; c <- 2nd source byte
         ld             a, [bc]         ; a <- HIGH nybble "doubled"
         ld             [hl+], a        ; 5rd row <- 2nd source byte (dbl'd)
         ld             [hl+], a        ; 6th row <- 2nd source byte (dbl'd)
         ld             [hl+], a        ; 7th row <- 2nd source byte (dbl'd)
         ld             [hl+], a        ; 8th row <- 2nd source byte (dbl'd)

         ENDR                           ; 50 cycles

         REPT           6               ; do last 24 (visible) rows

         pop            de              ; d <- 2nd source byte, e <- 1st byte

         ld             c, e            ; c <- 1st source byte
         ld             a, [bc]         ; a <- HIGH nybble "doubled"
         ld             [hl+], a        ; 1st row <- 1st source byte (dbl'd)
         inc            l               ; skip 2nd row (always zero)
         ld             [hl+], a        ; 3rd row <- 1st source byte (dbl'd)
         inc            l               ; skip 2nd row (always zero)

         ld             c, d            ; c <- 2nd source byte
         ld             a, [bc]         ; a <- HIGH nybble "doubled"
         ld             [hl+], a        ; 5rd row <- 2nd source byte (dbl'd)
         inc            l               ; skip 2nd row (always zero)
         ld             [hl+], a        ; 7th row <- 2nd source byte (dbl'd)
         inc            l               ; skip 2nd row (always zero)

         ENDR                           ; 126 cycles

         add            sp, -16         ; position source at top of 1st card

         dec            b               ; b = DoubleNybble_Lo >> 8

         REPT           2               ; do 1st 8 (visible) rows

         pop            de              ; d <- 2nd source byte, e <- 1st byte

         ld             c, e            ; c <- 1st source byte
         ld             a, [bc]         ; a <- LOW nybble "doubled"
         ld             [hl+], a        ; 1st row <- 1st source byte (dbl'd)
         ld             [hl+], a        ; 2nd row <- 1st source byte (dbl'd)
         ld             [hl+], a        ; 3rd row <- 1st source byte (dbl'd)
         ld             [hl+], a        ; 4th row <- 1st source byte (dbl'd)

         ld             c, d            ; c <- 2nd source byte
         ld             a, [bc]         ; a <- LOW nybble "doubled"
         ld             [hl+], a        ; 5rd row <- 2nd source byte (dbl'd)
         ld             [hl+], a        ; 6th row <- 2nd source byte (dbl'd)
         ld             [hl+], a        ; 7th row <- 2nd source byte (dbl'd)
         ld             [hl+], a        ; 8th row <- 2nd source byte (dbl'd)

         ENDR                           ; 50 cycles

         REPT           5               ; do next 20 (visible) rows

         pop            de              ; d <- 2nd source byte, e <- 1st byte

         ld             c, e            ; c <- 1st source byte
         ld             a, [bc]         ; a <- LOW nybble "doubled"
         ld             [hl+], a        ; 1st row <- 1st source byte (dbl'd)
         inc            l               ; skip 2nd row (always zero)
         ld             [hl+], a        ; 3rd row <- 1st source byte (dbl'd)
         inc            l               ; skip 2nd row (always zero)

         ld             c, d            ; c <- 2nd source byte
         ld             a, [bc]         ; a <- LOW nybble "doubled"
         ld             [hl+], a        ; 5rd row <- 2nd source byte (dbl'd)
         inc            l               ; skip 2nd row (always zero)
         ld             [hl+], a        ; 7th row <- 2nd source byte (dbl'd)
         inc            l               ; skip 2nd row (always zero)

         ENDR                           ; 105 cycles

         pop            de              ; d <- 2nd source byte, e <- 1st byte

         ld             c, e            ; c <- 1st source byte
         ld             a, [bc]         ; a <- LOW nybble "doubled"
         ld             [hl+], a        ; 1st row <- 1st source byte (dbl'd)
         inc            l               ; skip 2nd row (always zero)
         ld             [hl+], a        ; 3rd row <- 1st source byte (dbl'd)
         inc            l               ; skip 2nd row (always zero)

         ld             c, d            ; c <- 2nd source byte
         ld             a, [bc]         ; a <- LOW nybble "doubled"
         ld             [hl+], a        ; 5rd row <- 2nd source byte (dbl'd)
         inc            l               ; skip 2nd row (always zero)
         ld             [hl+], a        ; 7th row <- 2nd source byte (dbl'd)

         ; 391 cycles to finish copying, 221 bytes

         ld             sp, Save_BC
         pop            bc              ; bc <- [Save_BC]

         inc            b               ; inc ML_TOP
         dec            c               ; dec #/moving objects in queue
         jp             nz, MO_CTV_Loop

         ld             a, b
         ld             [ML_TOP], a     ; update ML_TOP

         jp             CopyToVRAM

M14_PAD  DS             $13 + 1

MO_Copy15::

         ; YRES  = 1 (copy 16 rows)
         ; XSIZE = 1 (two cards wide)
         ; YSIZE = 1
         ; YFULL = 1 (write each row eight times)

         pop            hl              ; hl <- MO's data address
         pop            de              ; de <- MO's VRAM address

         ld             sp, Save_BC + 2
         push           bc              ; [Save_BC] <- bc

         ld             sp, hl          ; sp <- MO's data address
         ld             l, e
         ld             h, d            ; hl <- MO's VRAM address

         ld             b, DoubleNybble_Hi >> 8

         pop            de              ; d <- 2nd source byte, e <- 1st byte

         ld             c, e            ; c <- 1st source byte
         ld             a, [bc]         ; a <- HIGH nybble "doubled"
         ld             [hl+], a        ; 1st row <- 1st source byte (dbl'd)
         ld             [hl+], a        ; 2nd row <- 1st source byte (dbl'd)
         ld             [hl+], a        ; 3rd row <- 1st source byte (dbl'd)
         ld             [hl+], a        ; 4th row <- 1st source byte (dbl'd)
         ld             [hl+], a        ; 5th row <- 1st source byte (dbl'd)
         ld             [hl+], a        ; 6th row <- 1st source byte (dbl'd)
         ld             [hl+], a        ; 7th row <- 1st source byte (dbl'd)
         ld             [hl+], a        ; 8th row <- 1st source byte (dbl'd)

         ld             c, d            ; c <- 2nd source byte
         ld             a, [bc]         ; a <- HIGH nybble "doubled"
         ld             [hl+], a        ; 9rd row <- 2nd source byte (dbl'd)
         ld             [hl+], a        ; 10th row <- 2nd source byte (dbl'd)
         ld             [hl+], a        ; 11th row <- 2nd source byte (dbl'd)
         ld             [hl+], a        ; 12th row <- 2nd source byte (dbl'd)
         ld             [hl+], a        ; 13rd row <- 2nd source byte (dbl'd)
         ld             [hl+], a        ; 14th row <- 2nd source byte (dbl'd)
         ld             [hl+], a        ; 15th row <- 2nd source byte (dbl'd)
         ld             [hl+], a        ; 16th row <- 2nd source byte (dbl'd)

         REPT           3               ; do next 24 (visible) rows

         pop            de              ; d <- 2nd source byte, e <- 1st byte

         ld             c, e            ; c <- 1st source byte
         ld             a, [bc]         ; a <- HIGH nybble "doubled"
         ld             [hl+], a        ; 1st row <- 1st source byte (dbl'd)
         inc            l               ; skip 2nd row (always zero)
         ld             [hl+], a        ; 3rd row <- 1st source byte (dbl'd)
         inc            l               ; skip 4th row (always zero)
         ld             [hl+], a        ; 5th row <- 1st source byte (dbl'd)
         inc            l               ; skip 6th row (always zero)
         ld             [hl+], a        ; 7th row <- 1st source byte (dbl'd)
         inc            l               ; skip 8th row (always zero)

         ld             c, d            ; c <- 2nd source byte
         ld             a, [bc]         ; a <- HIGH nybble "doubled"
         ld             [hl+], a        ; 9rd row <- 2nd source byte (dbl'd)
         inc            l               ; skip 10th row (always zero)
         ld             [hl+], a        ; 11th row <- 2nd source byte (dbl'd)
         inc            l               ; skip 12th row (always zero)
         ld             [hl+], a        ; 13rd row <- 2nd source byte (dbl'd)
         inc            l               ; skip 14th row (always zero)
         ld             [hl+], a        ; 15th row <- 2nd source byte (dbl'd)
         inc            l               ; skip 16th row (always zero)

         ENDR                           ; 99 cycles

         add            sp, -8          ; position source at top of 1st card

         dec            b               ; b = DoubleNybble_Lo >> 8

         pop            de              ; d <- 2nd source byte, e <- 1st byte

         ld             c, e            ; c <- 1st source byte
         ld             a, [bc]         ; a <- LOW nybble "doubled"
         ld             [hl+], a        ; 1st row <- 1st source byte (dbl'd)
         ld             [hl+], a        ; 2nd row <- 1st source byte (dbl'd)
         ld             [hl+], a        ; 3rd row <- 1st source byte (dbl'd)
         ld             [hl+], a        ; 4th row <- 1st source byte (dbl'd)
         ld             [hl+], a        ; 5th row <- 1st source byte (dbl'd)
         ld             [hl+], a        ; 6th row <- 1st source byte (dbl'd)
         ld             [hl+], a        ; 7th row <- 1st source byte (dbl'd)
         ld             [hl+], a        ; 8th row <- 1st source byte (dbl'd)

         ld             c, d            ; c <- 2nd source byte
         ld             a, [bc]         ; a <- LOW nybble "doubled"
         ld             [hl+], a        ; 9rd row <- 2nd source byte (dbl'd)
         ld             [hl+], a        ; 10th row <- 2nd source byte (dbl'd)
         ld             [hl+], a        ; 11th row <- 2nd source byte (dbl'd)
         ld             [hl+], a        ; 12th row <- 2nd source byte (dbl'd)
         ld             [hl+], a        ; 13rd row <- 2nd source byte (dbl'd)
         ld             [hl+], a        ; 14th row <- 2nd source byte (dbl'd)
         ld             [hl+], a        ; 15th row <- 2nd source byte (dbl'd)
         ld             [hl+], a        ; 16th row <- 2nd source byte (dbl'd)

         REPT           2               ; do next 16 (visible) rows

         pop            de              ; d <- 2nd source byte, e <- 1st byte

         ld             c, e            ; c <- 1st source byte
         ld             a, [bc]         ; a <- LOW nybble "doubled"
         ld             [hl+], a        ; 1st row <- 1st source byte (dbl'd)
         inc            l               ; skip 2nd row (always zero)
         ld             [hl+], a        ; 3rd row <- 1st source byte (dbl'd)
         inc            l               ; skip 4th row (always zero)
         ld             [hl+], a        ; 5th row <- 1st source byte (dbl'd)
         inc            l               ; skip 6th row (always zero)
         ld             [hl+], a        ; 7th row <- 1st source byte (dbl'd)
         inc            l               ; skip 8th row (always zero)

         ld             c, d            ; c <- 2nd source byte
         ld             a, [bc]         ; a <- LOW nybble "doubled"
         ld             [hl+], a        ; 9rd row <- 2nd source byte (dbl'd)
         inc            l               ; skip 10th row (always zero)
         ld             [hl+], a        ; 11th row <- 2nd source byte (dbl'd)
         inc            l               ; skip 12th row (always zero)
         ld             [hl+], a        ; 13rd row <- 2nd source byte (dbl'd)
         inc            l               ; skip 14th row (always zero)
         ld             [hl+], a        ; 15th row <- 2nd source byte (dbl'd)
         inc            l               ; skip 16th row (always zero)

         ENDR                           ; 66 cycles

         pop            de              ; d <- 2nd source byte, e <- 1st byte

         ld             c, e            ; c <- 1st source byte
         ld             a, [bc]         ; a <- LOW nybble "doubled"
         ld             [hl+], a        ; 1st row <- 1st source byte (dbl'd)
         inc            l               ; skip 2nd row (always zero)
         ld             [hl+], a        ; 3rd row <- 1st source byte (dbl'd)
         inc            l               ; skip 4th row (always zero)
         ld             [hl+], a        ; 5th row <- 1st source byte (dbl'd)
         inc            l               ; skip 6th row (always zero)
         ld             [hl+], a        ; 7th row <- 1st source byte (dbl'd)
         inc            l               ; skip 8th row (always zero)

         ld             c, d            ; c <- 2nd source byte
         ld             a, [bc]         ; a <- LOW nybble "doubled"
         ld             [hl+], a        ; 9rd row <- 2nd source byte (dbl'd)
         inc            l               ; skip 10th row (always zero)
         ld             [hl+], a        ; 11th row <- 2nd source byte (dbl'd)
         inc            l               ; skip 12th row (always zero)
         ld             [hl+], a        ; 13rd row <- 2nd source byte (dbl'd)
         inc            l               ; skip 14th row (always zero)
         ld             [hl+], a        ; 15th row <- 2nd source byte (dbl'd)

         ; 303 cycles to finish copying, 181 bytes

         ld             sp, Save_BC
         pop            bc              ; bc <- [Save_BC]

         inc            b               ; inc ML_TOP
         dec            c               ; dec #/moving objects in queue
         jp             nz, MO_CTV_Loop

         ld             a, b
         ld             [ML_TOP], a     ; update ML_TOP

         jp             CopyToVRAM

; **
; MO_CopyToVRAM:  Copies the bitmap data of MOs queued in MOVELIST to their
;                 appropriate locations in VRAM, taking into account the
;                 status of their YRES, XSIZE, YSIZE and YFULL bits (thus,
;                 the equivalent of up to 8 cards may be copied for ea. MO).
;
; Parameters:     [rSVBK] must already be set to WRAM bank #3.
;
; Notes:          Each copying operation may take from 84 to 391 cycles
;                 depending upon the status of its YRES, XSIZE, YSIZE and
;                 YFULL bits.
;

MO_CopyToVRAM:

         ld             a, 5            ; a = #/WRAM bank where MOVELIST is
         ldh            [rSVBK], a      ; switch to WRAM bank #5

         ld             hl, ML_BOTTOM
         ld             a, [hl+]        ; a <- ML_BOTTOM
         ld             b, [hl]         ; b <- ML_TOP

         sub            b               ; a <- ML_BOTTOM - ML_TOP
                                        ;      (#/moving objects in queue)
         jr             z, CopyToVRAM

         ld             c, a            ; c <- #/moving objects in queue

MO_CTV_Loop:

         ldh            a, [rLY]        ; a <- LCDC Y-Coordinate (144..153)

         dec            a               ; make 144..153 -> 143..152, 0 -> 255
         cp             151             ; was it >= 152 ?
         jr             nc, MO_CTV_Exit ; yes, so may not be enough time

         ld             l, b              ; l = ML_TOP
         ld             h, MOVELIST >> 8  ; hl -> MOVELIST[ ML_TOP ]

         ld             l, [hl]         ; l <- LOW byte of MO record address
         ld             h, MO >> 8      ; hl -> MO record @ attribute byte #1

         ld             a, [hl]         ; a <- MO attribute byte #1
;         and            $3F             ; clear both ReCopy & MOVELIST-Queue
;         ld             [hl+], a        ; store out new MO attribute byte #1

         and            $BF             ; clear MOVELIST-Queue only
         ld             [hl+], a        ; store out new MO attribute byte #1

         res            7, a            ; * make sure ReCopy reset

         ld             sp, hl          ; sp -> MO @ data address

         ld             l, a
         add            a, MO_Copy00 >> 8 - $20
         ld             h, a

         jp             [hl]            ; jump to copying routine

         ; ^ 27 cycles

MO_CTV_Exit:                            ; entry point used by MO_CopyToVRAM

         ld             a, b
         ld             [ML_TOP], a     ; update ML_TOP

; **
; CopyToVRAM:  Copies the graphic data of tiles whose TILE addresses
;              have been queued in COPYLIST to VRAM.
;
; Modifies:    [rSVBK] will be left in WRAM bank #6.
;
; Notes:       Each copying operation may take from 39 to 77 cycles.
;

CopyToVRAM:

         ld             a, 6            ; a = #/WRAM bank where COPYLIST is
         ldh            [rSVBK], a      ; switch to WRAM bank #6

         ld             hl, CL_BOTTOM
         ld             a, [hl-]        ; a <- CL_BOTTOM
         ld             b, [hl]         ; b <- CL_TOP

         sub            b               ; a = CL_BOTTOM - CL_TOP
                                        ;     (#/tiles in queue)
         jp             z, CopyToVRAM_Ret

         ; ^ 16/15 cycles

         ld             c, a            ; c <- #/tiles in queue

         ldh            a, [rLY]        ; a <- LCDC Y-Coordinate (144..153)

         ld             l, b
         ld             h, COPYLIST >> 8

         ld             e, [hl]
         inc            h
         ld             h, [hl]
         ld             l, e            ; hl <- TILE @ MakeUpBank + Queue

         res            6, [hl]         ; clear COPYLIST-Queue bit

         ld             sp, hl          ; sp -> TILE @ MakeUpBank + Queue

         cp             144             ; is LCDC Y-Coordinate in 0..143 ?
         ret            nc              ; no, so OK to copy freely in VBL

         ; ^ 24/21 cycles

.HBL     ldh            a, [rSTAT]
         and            $03             ; are we in H-Blank period ?
         jr             nz, .HBL        ; no, so not OK to copy yet

         ret
